/* 
   Copyright 1994-2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.  

   You may contact the author at:

   mailto::camille@bluegrass.net

   or by snail mail at:

   David Lindauer
   850 Washburn Ave Apt 99
   Louisville, KY 40222
*/
/*
 * handle ALL declarative statements
 */
#include        <stdio.h>
#include 				<string.h>
#include        "lists.h"
#include        "expr.h"
#include        "c.h"
#include        "errors.h"

extern SYM *currentfunc,*declclass ;

void insertfriend(SYM *decl, SYM *tfriend)
{
#ifdef CPLUSPLUS
	char buf[100];
	SYM *sp,*sp1;
   sp1 = search("$$FRIENDS$$",&decl->tp->lst);
   if (sp1) {
      sp1->tp->lst.tail = sp1->tp->lst.tail->next = tfriend ;
//      if (!search(tfriend->name,&sp1->tp->lst))
//         insert(tfriend,&sp1->tp->lst) ;
   } else {
      sp = xalloc(sizeof(SYM));
      sp->storage_class = sc_friendlist;
      sp->name = "$$FRIENDS$$";
      sp->tp = maketype(bt_defunc,0);
      sp->tp->sp = sp;
      sp->tp->lst.head = sp->tp->lst.tail = tfriend;
      sp->parentclass = declclass;
      insert(sp,&decl->tp->lst);
   }
#endif
}
int friendsearch(SYM *spx, char *name, SYM *sp1)
{
   SYM *sp2 ;
   sp1 = sp1->tp->lst.head ;
   while (sp1) {
      if (!strcmp(sp1->name,name)) {
         if (!strcmp(sp1->parentclass->name,spx->originalparentclass->name))
            return 1 ;
      }
      sp1 = sp1-> next ;
   }
   return 0 ;
}
int isfriend(SYM *spx,TABLE *tbl)
{
   SYM *sp1 = search("$$FRIENDS$$", tbl) ;
   if (sp1) {
      if (friendsearch(spx,currentfunc->name, sp1))
         return 1 ;
      if (friendsearch(spx,currentfunc->parentclass->name, sp1))
         return 1 ;
   }
   return 0 ;
}